// This JavaScript file contains functionality relating to the context menu.

// ****************************************************************************
// Set-up variables needed for common functionality
// ****************************************************************************

// Index of next window to arrange. (See arrangeWindows(), et al.
var nextWindow = 0;


//array holds the id of each row
var mId = new Array();

var ctx_isIE = true;
if (navigator.userAgent.toLowerCase().indexOf("gecko") > -1) {
   ctx_isIE = false;
}

//array holds the text of the Standard options of the context menu.
var mText = new Array(2);
   mText[0]="A<span class=\"hMenuUnderline\">r</span>range windows";
   mText[1]="Clo<span class=\"hMenuUnderline\">s</span>e all";
   mText[2]="<span class=\"hMenuUnderline\">P</span>rint page";

//array holds the reference to methods for the standard options
var mOnClick = new Array(2);
   mOnClick[0] = "arrangeWindows()";
   mOnClick[1] = "ctxCloseAll()";
   mOnClick[2] = "printPage()";

//Holds the title of the desktop window.
var mDeskTitle;

//Holds menu array.
var mWin = new Array();

// holds different values to call arrays from desktop or application pages.
var win = null;

// ****************************************************************************
// ctxMenuFocus
// set focus and highlight to the menu item
// ****************************************************************************
function ctxMenuFocus(id) {
   var element = window.document.getElementById(id);
   element.className = "ctxMenuHighlighted";
   element = getLinkById(id);
   element.className = "ctxMenuHighlighted";
}

// ****************************************************************************
// ctxMenuBlur
// remove focus and highlight from the menu item
// ****************************************************************************
function ctxMenuBlur(id) {
   var element = window.document.getElementById(id);
   element.className = "ctxMenu";
   element = getLinkById(id);
   element.className = "ctxMenu";
}

// ****************************************************************************
// getLinkById
// get the id of all the links on the page
// ****************************************************************************
function getLinkById(id) {
   for (var i=0; i < window.document.links.length; i++) {
      var element = window.document.links[i];
      if (element.id == id) {
         return element;
      }
   }
   return null;
}

// ****************************************************************************
// ctxCloseAll
// close all app windows and hide context menu
// ****************************************************************************
function ctxCloseAll(){
   closeAll();
   hideContextMenu();
}

// ****************************************************************************
// printPage
// print page, hide context menu so it won't be in print out.
// ****************************************************************************
function printPage(){
   hideContextMenu();
   window.print();
}

// ****************************************************************************
// showContextMenu
// Displays the context menu.
// ****************************************************************************
function showContextMenu(e){
   if (!customCtxMenu) {
      return true;
   }

   openingCtxMenu = true;

   winOpen();
   //calls the function that generates the table HTML
   var htmlStr = GetFormHTML();
   innerDivHTML(htmlStr);
   if(e != null || ie != null){
      //Find out how close the mouse is to the corner of the window
      var rightedge  = ie ? document.body.clientWidth-event.clientX : window.innerWidth-e.clientX
      var bottomedge = ie ? document.body.clientHeight-event.clientY : window.innerHeight-e.clientY

      var windowTop = ie ? document.body.clientHeight-divobj.offsetHeight : window.innerHeight-divobj.offsetHeight
      var windowLeft = ie ? document.body.clientWidth-divobj.offsetWidth : window.innerWidth-divobj.offsetWidth-17 // 17 added for width of scrollbar

      var clickX = ie ? event.clientX : e.clientX
      var clickY = ie ? event.clientY : e.clientY

      if (clickX < 0){
         clickX = 0;
      }

      if (clickY < 0){
         clickY = 0;
      }

      if (rightedge < 0){
         clickX += rightedge;
      }

      if (bottomedge < 0){
         clickY += bottomedge;
      }

      //if the horizontal distance isn't enough to accomodate the width of the context menu
      if (rightedge < divobj.offsetWidth)
         //move the horizontal position of the menu to the left, leaving the right side of the menu inline with the window
         divobj.style.left = windowLeft
      else
         //position the horizontal position of the menu where the mouse was clicked
         divobj.style.left = ie ? document.body.scrollLeft+clickX : window.pageXOffset+clickX


      //same concept with the vertical position
      if (bottomedge < divobj.offsetHeight)
         divobj.style.top = windowTop
      else
         divobj.style.top = ie ? document.body.scrollTop+clickY : window.pageYOffset+clickY
   }
   else{
      divobj.style.left = 0;
      divobj.style.top  = 0;
   }

   divobj.style.visibility="visible"

   //set iframe attributes to be the same as div attributes
   //don't set in os2 not needed.
   if (ie) {
      iframeobj.style.visibility=divobj.style.visibility
      iframeobj.style.left=divobj.style.left
      iframeobj.style.top=divobj.style.top
      iframeobj.style.height=divobj.offsetHeight
      iframeobj.style.width=divobj.offsetWidth
   }

   divFocus();

   openingCtxMenu = false;
   return false;
}

// ****************************************************************************
// divFocus
// Sets focus to the first row within the div.
// ****************************************************************************
function divFocus() {
   for (var i=0; i < document.links.length; i++) {
      var elementId = document.links[i].id;
      if (elementId.substring(0, 10) == "hafmenuctx") {
         // first link in context menu, set focus and stop looping
         document.links[i].focus();
         break;
      }
   }
}

// ****************************************************************************
// hideContextMenuTry
// Hides the context menu if required
// ****************************************************************************
function hideContextMenuTry(event) {
   // If we clicked on the context menu, do not hide it
   if (event.clientX < divobj.offsetLeft || event.clientX > divobj.offsetLeft + divobj.offsetWidth
   ||  event.clientY < divobj.offsetTop  || event.clientY > divobj.offsetTop  + divobj.offsetHeight)
   {
      hideContextMenu();
   }
}

// ****************************************************************************
// hideContextMenu
// Hides the context menu
// ****************************************************************************
function hideContextMenu() {
   if (((!openingCtxMenu) && (!navigatingCtxMenu)) || (ie)) {
      divobj.style.visibility = "hidden"
      iframeobj.style.visibility = divobj.style.visibility
   }
}

// ****************************************************************************
// menuDescription
// Class to hold menu item details
// ****************************************************************************
function menuDescription(id, title, hotKey) {
   this.id = id;                          // Page id returned when the window was opened
   this.title = title;                    // Page title as defined by the <title> tag
   this.hotKey = hotKey;                  // hotKey of menu item
}

// ****************************************************************************
// winOpen
// populates the mWinTitle and mWinId arrays.
// ****************************************************************************
function winOpen(){
   var k = 49;
   var winsArrayLength = getApplicationWinsLength();
   if (isDesktop){
      win = window;
   }
   else {
      win = opener.window;
   }
   mDeskTitle = win.document.title;
   mDeskTitle = mDeskTitle.replace(/\xA0*$/, "");  // remove trailing hard spaces to find true length of string.
   if (mDeskTitle.length > 99){
      mDeskTitle = (mDeskTitle.substring(0, 98)+"*");
   }

   if (winsArrayLength > 0){
   	j = 0;
      for (apps in win.applicationWindows){
        // sets the length of the menu, uses charctercode
        while (k < 58){
           mWin[j] = new menuDescription();
           mWin[j].id = win.applicationWindows[apps].winObj.name;
           mWin[j].title = win.applicationWindows[apps].title;
           mWin[j].title = mWin[j].title.replace(/\xA0*$/, "");   // remove trailing hard spaces to find true length of string.
           mWin[j].title = mWin[j].title.replace(/\xA0/g, " ");   // replace hard spaces with soft spaces
           if (mWin[j].title.length > 99){
              mWin[j].title = (mWin[j].title.substring(0, 98)+"*");
           }
           mWin[j].hotKey = k;

           if (k>56 && k<65){
              k = 64;
           }
           k++
           break;
        }
        j++;
      }   
   }
   for (i=0; i<mWin.length+4; i++){
      mId[i] = ("hafmenuctx_"+i);
   }
}

// ****************************************************************************
// switchContextWindow
// moves focus to the window selected
// ****************************************************************************
function switchContextWindow(winId){
   hideContextMenu()

   if(isDesktop){
      win = window;
   }
   else{
      win = opener.window;
   }

   for(apps in win.applicationWindows) {
      if (winId == win.applicationWindows[apps].winObj.name){
        if (ctx_isIE == true) {
           win.applicationWindows[apps].winObj.document.focus();
           win.applicationWindows[apps].winObj.focus(); //if the document is minimised ensure it get's popped to the front.
        }
        else {
           win.applicationWindows[apps].winObj.focus();
        }
        break;
      }
   }
}

// ****************************************************************************
// currentPageFocus
// Sets currentPage property when JSP page receives focus, called through
// the onfocusFunction within final.js
// ****************************************************************************
function currentPageFocus(){
	if (!opener.closed) {
       opener.currentPage = this;
    }
}

// ****************************************************************************
// arrangeWindows
// Hides the context menu and starts arranging windows.
// ****************************************************************************
function arrangeWindows() {
   hideContextMenu();
   selectDesktop();
   nextWindow = 0;
   arrangeOneWindow();
}

// ****************************************************************************
// arrangeOneWindow
// Move a window back to its original position and set a timeout to call this
// function again for the next window, if there is one, in 2/100ths of a second
// for IE or as soon as possible for Mozilla.
// ****************************************************************************
function arrangeOneWindow() {
   var coords;
   var win;
	var arrayIndex = 0;
	
   if (isDesktop) {
      win = window;
   }
   else {
      win = opener.window;
   }

   coords = win.calculateWindowCoords();
   
	//search through applicationWindows array for the next window
   for (apps in win.applicationWindows) {
   	if (arrayIndex == nextWindow) {
   		//this is the next window so give it focus and move it to correct position
	   	currentWin = win.applicationWindows[apps].winObj;
	   	currentWin.focus();	
   		currentWin.moveTo(coords.posX,coords.posY);
   		break;
   	}
   	arrayIndex++;
   }
   
   // A (relatively) big delay for IE, as short as possible for Mozilla. (Also next function.)
   // The delay is neccessary for IE/Windows to notice the move instruction before the next
   // move is issued. Redrawing the window takes longer than this delay so the user will barely
   // notice it - even if we have several windows to do.
   window.setTimeout("setFocusToDocument('" + currentWin + "')", ctx_isIE ? 20: 1);
}

// ****************************************************************************
// setFocusToDocument
// For IE, gives focus to the document of the window being processed. For all
// browsers, arranges for arrangeOneWindow() to be called for the next window,
// if there is one, in 2/100ths of a second for IE or as soon as possible for 
// Mozilla.
// ****************************************************************************
function setFocusToDocument(currentWin) {
   var win;
   if (isDesktop) {
      win = window;
   }
   else {
      win = opener.window;
	}
	
	//search through applicationWindows array to find the current window
	for (apps in win.applicationWindows) {
		if (win.applicationWindows[apps].winObj.name == currentWin && ctx_isIE) {
			win.applicationWindows[apps].winObj.document.focus();
			break;
		}
	}
	
   nextWindow++;

   if (nextWindow < getApplicationWinsLength()) {
      window.setTimeout("arrangeOneWindow();", ctx_isIE ? 20: 1);
   }
}

// ****************************************************************************
// hotKeySwitchWindow
// uses hotKey to switch windows.
// ****************************************************************************
function hotKeySwitchWindow(keyCode){
   for(h=0; h < mWin.length; h++) {
      if(mWin[h] != null){
         if (keyCode == mWin[h].hotKey){
            hideContextMenu();
            if(isDesktop){
               win = window;
            }
            else{
               win = opener.window;
            }
			   for(apps in win.applicationWindows) {
			      if (mWin[h].id == win.applicationWindows[apps].winObj.name){
			        if (ctx_isIE == true) {
         			  win.applicationWindows[apps].winObj.document.focus();
			           win.applicationWindows[apps].winObj.focus(); //if the document is minimised ensure it get's popped to the front.
			        }
			        else {
			           win.applicationWindows[apps].winObj.focus();
			        }
			        break;
			      }
			   }            
         }
      }
   }
}

// ****************************************************************************
// GetFormHTML
// Generates the HTML for the menu.
// ****************************************************************************
function GetFormHTML(){

   var htmlStr = "";

   // create html for first section of context menu
   htmlStr += ("<table border=0 cellpadding=2 cellspacing=0 width=\"100%\">\n");

   for (i=0;i<3;i++){
      if (navigator.userAgent.toLowerCase().indexOf("gecko") == -1) {
         htmlStr += ("   <tr id="+mId[i]+"_row CLASS=\"ctxMenu\" width=\"100%\" onClick=\""+mOnClick[i]+"\" onkeyup=\"handleContextKey(event, '"+mId[i]+"')\">\n");
      }
      else {
         htmlStr += ("   <tr id="+mId[i]+"_row CLASS=\"ctxMenu\" width=\"100%\" onmouseup=\""+mOnClick[i]+"\" onkeyup=\"handleContextKey(event, '"+mId[i]+"')\">\n");
      }
      htmlStr += ("      <td colspan=2  id="+mId[i]+" CLASS=\"ctxMenu\"><a CLASS=\"ctxMenu\" id="+mId[i]+" onblur=\"ctxMenuBlur('"+mId[i]+"')\" onfocus=\"ctxMenuFocus('"+mId[i]+"')\" href=\"javascript:NullEvent()\" ></a>"+mText[i]+"</td>\n");
      htmlStr += ("   </tr>\n");
   }

   // Dividing line
   htmlStr += ("      <tr>\n");
   htmlStr += ("         <td colspan=2 height=2><hr></hr></td>\n");
   htmlStr += ("      </tr>\n");

   // create html for second section of context menu
   var k=48;
   var winArrayLength = getApplicationWinsLength();
   if (isDesktop){
      win = window;
   }
   else{
      win = opener.window;
   }
   
   htmlStr += ("   <tr id=hafmenuctx_3 class=\"ctxMenu\" width=\"100%\" onClick=\"selectDesktop()\" onkeyup=\"handleContextKey(event, 'hafmenuctx_3')\">\n");
   htmlStr += ("      <td colspan=2><a class=\"ctxMenu\" id=hafmenuctx_3 onblur=\"ctxMenuBlur('hafmenuctx_3')\" onfocus=\"ctxMenuFocus('hafmenuctx_3')\" href=\"javascript:NullEvent()\" ><span class=\"hMenuUnderline\">0</span>&nbsp;"+mDeskTitle+"</a></td>\n");
   htmlStr += ("   </tr>\n");

   if(getApplicationWinsLength() > 0){
      for (i=0;i<winArrayLength;i++){
         if(mWin[i]!= null){
            hotkey = String.fromCharCode(mWin[i].hotKey);
            htmlStr += ("   <tr id="+mId[i+4]+" class=\"ctxMenu\" width=\"100%\" onClick=\"switchContextWindow('"+mWin[i].id+"')\" onkeyup=\"handleContextKey(event, '"+mId[i+4]+"')\">\n");
            htmlStr += ("      <td colspan=2><a class=\"ctxMenu\" id="+mId[i+4]+" onblur=\"ctxMenuBlur('"+mId[i+4]+"')\" onfocus=\"ctxMenuFocus('"+mId[i+4]+"')\" href=\"javascript:NullEvent()\" ><span class=\"hMenuUnderline\">"+hotkey+"</span>&nbsp;"+mWin[i].title+"</a></td>\n");
            htmlStr += ("   </tr>\n");
            if(mWin[i].hotKey>67){
               break;
            }
         }
      }
   }

   htmlStr += ("</table>");

   return htmlStr;
}

// ****************************************************************************
// innerDivHTML
// places the generated HTML within the div on the page
// ****************************************************************************
function innerDivHTML(divCtxMenu)
{
   var theDiv = window.document.getElementById('ctxdiv');
   theDiv.innerHTML= divCtxMenu;
}
