/**************************************************************************************/
/* Global Variables                                                                   */
/**************************************************************************************/
  
  var formName="HAFForm";
  /** formHasBeenSubmitted is set by submitEventOrOp and checked by 
   *  the double click routines 
  */
  var formHasBeenSubmitted = false;
  
  // register abCloseQueue as a property of the document so that it can be accessed from within IFrames
  // and also from other pages.
  window.document.abCloseQueue = new Array();

  var abnormalWinClose = true;  
  
/**************************************************************************************/
/*                                                                                    */
/*    Set the focus when a page is initially loaded.                                  */
/*    First try to find a field on the form 'formName' which is not hidden, and put   */
/*    on this field, otherwise, put focus on the first link of the page               */
/*                                                                                    */
/**************************************************************************************/
function setFieldFocus(initialFocusId) {
  if (document.forms.length > 0)  {
      var formNo = 0;
      for(;formNo < document.forms.length; formNo++) {
         if (document.forms[formNo].name == formName) {
            break;
         }
      }

      if (formNo < document.forms.length && document.forms[formNo].elements.length > 0) {
         var i = 0;
         if (initialFocusId != null && initialFocusId.length > 0) {
            // Looking for a specific field in the form
            var id;
            id = document.getElementById(initialFocusId);
            if (id && id.type != "hidden") {
               id.focus();
            }
            else {
               var focusSet = false;
               // Field not found, may be because it is a multi-part field that has
               // numeric suffixes - attempt to set to highest to lowest suffix
               for (i=3; i>0; i--) {
                  el = document.getElementById(initialFocusId + "_" + i);
                  if (el && el.type != "hidden") {
                     el.focus();
                     focusSet = true;
                  }
               }
               if (!focusSet) {
                  // still not found, so set to first field we can find!
                  setFirstFocusable();
               }
            }
         }
         else {
            // Looking for first field in the form that can take focus
            for (; i < document.forms[formNo].elements.length; i++) {
               elementType = document.forms[formNo].elements[i].type;
               if ((elementType != null) && (elementType != "hidden") && (!document.forms[formNo].elements[i].disabled)) {
                  // first not null/not hidden field, set focus and stop looping
                  document.forms[formNo].elements[i].focus();
                  break;
               }
            }

            if (i == document.forms[formNo].elements.length) {
               // there are no non-hidden fields on the form
               setFirstFocusable();
            }
         }
      }
      else {
         // the form has no fields
         setFirstFocusable();
      }
   }
   else {
      // there is no form named HAFForm
      setFirstFocusable();
   }
}

/**************************************************************************************/
/*                                                                                    */
/*    Sets focus to the first focusable item on the page. If we can't find one then   */
/*    try setting to the first menu we can find. If we can;t do that - givce up!      */
/*                                                                                    */
/**************************************************************************************/
function setFirstFocusable() {
   var i;
   for (i=0; i < document.links.length; i++) {
   	 if ((document.links[i].id.substring(0, 9) != "menuItem_") && (document.links[i].id.substring(0, 4) != "xxx_")) {
       	 document.links[i].focus();
       	 done = true;
       	 break;
     }
   }
   if (i == document.links.length) {
      // Not found any focusable items so try menu
      for (i=0; i < document.links.length; i++) {
         if (document.links[i].id.substring(0, 9) == "menuItem_") {
            document.links[i].focus();
            done = true;
            break;
         }
      }
   }
}

/**************************************************************************************/
/*                                                                                    */
/*    This function is called when a JSP page is loaded, and the page is to have      */
/*    field focus set                                                                 */
/*    NB the name of this function is used within HTMLJSPStart, do NOT change the name*/
/*                                                                                    */
/**************************************************************************************/
function onloadFunction(initialFocusId){
   onloadNoFocusFunction();
   setFieldFocus(initialFocusId);
}
/**************************************************************************************/
/*                                                                                    */
/*    This function is called when a JSP page is loaded  and field focus is to be set */
/*    NB the name of this function is used within HTMLJSPStart, do NOT change the name*/
/*    To add more functionality, write a new function and chain into this function    */
/*                                                                                    */
/**************************************************************************************/
function onloadNoFocusFunction(){
   hksWindowOpened();
}

/**************************************************************************************/
/*                                                                                    */
/*    This function is called when a JSP page is unloaded                             */
/*    NB the name of this function is used within HTMLJSPStart, do NOT change the name*/
/*    To add more functionality, write a new function and chain into this function    */
/*                                                                                    */
/**************************************************************************************/
function onunloadFunction(){
   hksWindowClosed();      
   registerClosingPage();
   if (!formHasBeenSubmitted && !opener.closed) {
      abnormalWindowClose();
   }
}



/**************************************************************************************/
/*                                                                                    */
/*    This function is called when the desktop is unloaded                            */
/*    NB the name of this function is used within DSKHTMLJSPPage, do NOT change the   */
/*    name.                                                                           */
/*    To add more functionality, write a new function and chain into this function    */
/*                                                                                    */
/**************************************************************************************/
function hafOnunloadDesktopFunction(){
      if ((abnormalWinClose == true) && (window.frames['closeAllIframe'].document.forms["closeAllForm"].elements["HAFOperator.closeAllMechanism"].value != "sign_off")) {
         //At this point a function to close all open windows is called
         closeAllWinsAfterAbnormalDSKClose();
      }
}


/**************************************************************************************/
/*                                                                                    */
/*    This function is called when a JSP page gains focus                             */
/*    NB the name of this function is used within HTMLJSPStart, do NOT change the name*/
/*    To add more functionality, write a new function and chain into this function    */
/*                                                                                    */
/**************************************************************************************/
function onfocusFunction(){
   hksWindowReceivedFocus();
   currentPageFocus();
}

/**************************************************************************************/
/*                                                                                    */
/*    This function is called when a menu item or navigation control is activated.    */
/*    It sets the operation and/or event then submits the form                        */
/*    operationName is the name of the operation to be set, or null if operation      */
/*                  is not used                                                       */
/*    eventName     is the name of the event to be set, or null if event is not used  */
/*    NB the name of this function is used within HTMLMenu and HTMLNavigationControl, */
/*    do NOT change the name                                                          */
/*    To add more functionality, write a new function and chain into this function    */
/*                                                                                    */
/*    MAR: a global variable has been added to flag if a form has been submitted,     */
/*         this is checked by the double click blocking routines.                     */  
/*                                                                                    */
/**************************************************************************************/
function submitEventOrOp(operationName, eventName){
   abnormalWinClose = false; 
   if (document.forms.length > 0)  {
      var formNo = 0;
      for(;formNo < document.forms.length; formNo++) {
         if (document.forms[formNo].name == formName) {
            break;
         }
      }

      if (formNo < document.forms.length && document.forms[formNo].elements.length > 0) {
         if (operationName != null) {
            document.forms[formNo].dse_operationName.value = operationName;
         }

         if (eventName != null) {
            document.forms[formNo].dse_nextEventName.value = eventName;
         }

         if (!formHasBeenSubmitted) {
            formHasBeenSubmitted = true;
            document.forms[formNo].submit();
            displayPleaseWait();
            setHourglassOn(); /* to provide further user feedback when the form has been submitted */
         }
      }
   }
}

/**************************************************************************************/
/*                                                                                    */
/*    This function is called to submit the HTTPS Auto forwarding page.               */
/*                                                                                    */
/**************************************************************************************/
function autoSubmitHTTPSForwardingPage() {
   var formNo = 0;
   for(;formNo < document.forms.length; formNo++) {
      if (document.forms[formNo].name == formName) {
         break;
      }
   }

   document.forms[formNo].submit();
}

/**************************************************************************************/
/*                                                                                    */
/*    This function is called for mutually exclusive list boxes.                      */
/*    It deselects all selected list items in the list boxes specified by the         */
/*    parameter.                                                                      */
/*    ids           a comma seperated list of list box ids that are to have items     */
/*                  deselected                                                        */
/*                                                                                    */
/**************************************************************************************/
function deselectAll(ids) {
   // Split the IDs string into an array of individual IDs
   id = ids.split(",")

   // Find the form in the page
   if (document.forms.length > 0)  {
      for(formNo=0; formNo < document.forms.length; formNo++) {
         if (document.forms[formNo].name == formName) {
            break;
         }
      }

      // Find the list boxes and deselect all entries
      if (formNo < document.forms.length && document.forms[formNo].elements.length > 0) {
         for (i=0; i < document.forms[formNo].elements.length; i++) {
            elementid = document.forms[formNo].elements[i].id;
            for (j=0; j<id.length; j++) {
               if (elementid == id[j]) {
                  document.forms[formNo].elements[i].selectedIndex = -1;
               }
            }
         }
      }
   }
}


function displayPleaseWait() {
   // Hide the Application area
   // look for several tags in order of preference to find out where
   // to start hiding from.   
   var mainPageArea = document.getElementById("applicationStart");
   if (mainPageArea == null) {
      mainPageArea = document.getElementById("pagemenuarea");
   }
   if (mainPageArea == null) {
      mainPageArea = document.getElementById("mastheadEnd");
   }

   if (mainPageArea != null) {
      // set this and everything after it to hidden
      var sibling = mainPageArea;
      do {
         nextSibling = sibling.nextSibling; 
         if ("style" in sibling) {
            sibling.style.visibility="hidden"; // actually display="none" also makes invisible
            sibling.style.display="none"; // stop the element occupying page area
         }
         sibling = nextSibling;
      }
      while (sibling != null)
   }

   // have hidden the page area
   // now hide the menu (if there is one)
   {
      i=0;
      var cell = document.getElementById("tableCell_"+i);
       while (cell != null && cell != undefined) {
         cell.style.visibility="hidden";
         cell = document.getElementById("tableCell_"+ ++i);
      }
   }
   
   //!! now remove all  <select>'s to stop spurious scroll bars in IWB 1.1
   var aSelects = document.body.getElementsByTagName("SELECT");
   for (i=0;i<aSelects.length;i++) {
      aSelects[i].parentNode.removeChild(aSelects[i]);
  }


/* The following code is present in case there is a desire to display 
   a "please wait message or some such */
/********************************************************************   
*   // now construct the "please wait" text   
*  var divElement = document.createElement("DIV");
*  var tableElement = document.createElement("table");
*   tableElement.setAttribute("width", "100%");
*   tableElement.setAttribute("height", "50%");
*   divElement.appendChild(tableElement);
*   var rowElement = tableElement.insertRow(0);
*   var cellElement = rowElement.insertCell(0);
*   cellElement.setAttribute("Valign","center");
*   cellElement.setAttribute("align","center");
*   var fontElement = document.createElement("FONT");
*   fontElement.setAttribute("size","7");
*   var textElement = document.createTextNode("Please wait now");
*   cellElement.appendChild(fontElement);
*   fontElement.appendChild(textElement);
*
*   // and display it.
*   var formElement = document.forms.HAFForm;
*   if (formElement != null && formElement != undefined 
*         && mainPageArea != null && mainPageArea != undefined
*         && mainPageArea.parentNode != null) {
* //      formElement.insertBefore(divElement, formElement.childNodes[0]);
*      mainPageArea.parentNode.insertBefore(divElement, mainPageArea);
*   }
********************************************************************/   
}


/**
 * setHourglassOn sets the cursor style to an hourglass for all (in IE)
 * and most (in Mozilla) HTML components on the page. It is used to 
 * provide more feedback to the user than the default browser behaviour.
**/

function setHourglassOn() {
   // For MOZ and IE we can simply set document.body.style.cursor = "wait"; though this only affects unused "white" areas
   document.body.style.cursor = "wait";
   
   // for IE we can do all elements easily - if (true) below
   
   if (document.all) {
      // iterate through all children of the body setting the cursor to Hourglass
      for (i=0;i<document.all.length;i++) {
         if ("style" in document.all[i]) {
            document.all[i].style.cursor="wait";
         }
      }
   } 
   // for Mozilla we can do the easy to get at elements: images, links and anchors, other items are more difficult. 
   else
   {
      for (i=0;i<document.images.length;i++) {
         if ("style" in document.images[i]) {
            document.images[i].style.cursor="wait";
         }
      }
      
      for (i=0;i<document.links.length;i++) {
         if ("style" in document.links[i]) {
            document.links[i].style.cursor="wait";
         }
      }
      
      for (i=0;i<document.anchors.length;i++) {
         if ("style" in document.anchors[i]) {
            document.anchors[i].style.cursor="wait";
         }
      }
   }
}

/**
 * isAlreadySubmitted is a function that returns true if the form has
 * already been submitted to the server. It is extensively used as an
 * onclick event handler for double click prevention
**/

function isAlreadySubmitted() {
   return formHasBeenSubmitted; 
}


/**************************************************************************************/
/*                                                                                    */
/*    This function retrieves the processor Id of the application being closed        */
/*    abnormally. This processor Id is then added to a queue, reference is then       */ 
/*    made to an iframe.                                                              */
/*                                                                                    */
/**************************************************************************************/

function abnormalWindowClose() {

   // Get the processor Id of the application
   procIdOfApp = window.document.HAFForm.dse_processorId.value;
   
   // Add the processor Id to a queue
   window.opener.document.abCloseQueue.push(procIdOfApp);
   
   // Run the checkQueue function, from the abnormalWinCloseIframe.
   window.opener.frames["abnormalWinCloseIframe"].checkQueue();
}

/***************************************************************************************/
/*                                                                                     */
/*    This function closes the desktop and applications associated with it             */
/*                                                                                     */
/***************************************************************************************/

function closeAllWinsAfterAbnormalDSKClose() {

   appWindows = window.applicationWindows;

   if(appWindows != null) {

      for (appWindow in appWindows) {
         window.appWindows[appWindow].winObj.close();
         delete appWindows[appWindow];
      }
   }
}
