/*****************************************************************************
 *   Module : keyClass.js     
 *   Description: This file contains the functionality necessary to 
 *                create a key.
 * 
 *   Traceability to design : Represents the key class.
 *
 *   Modification History:
 *   Author               Date            Version              Reason
 *   D.Palmer           09-Jan-01         initial                -    
 *   D.Palmer           29-Jan-01         0.1                Added type.               
****************************************************************************/
        
   /**
    *  This function creates a key object from the provided parameters.
    */         
   function key(typeId, value, description, type) {
    
      // The ''+ is required to convert the parameters passed in by the Messaging Applet to String objects. 
      this.typeId      = ''+typeId;
      this.value       = ''+value;
      this.description = ''+description;
      this.type        = ''+type;                         

      //Within HBUS KLC the descriptions for customers can be up to 70 characters in length
      //This code checks to see if the length is over 50 for a customer and truncates it
      if(description.length>50 && typeId==1){
         this.description = ''+description.slice(0,50);
      }
  }
