/* Define the images for cache on start up*/
var imgOpen = new Image();
var imgClosed = new Image();
var imgGreyed = new Image();

/* Consts */
/* A global var - the items pool.  Property of menuItemHandler */
menuItemHandler.pool = new Array();
menuItem.CSS_INACTIVE = "menuItem";
menuItem.CSS_ACTIVE    = "menuItemActive";
menuItem.CLOSED          = "closed";
menuItem.OPEN              = "open";
menuItem.ACTIVE           = "active";
menuItem.INACTIVE        = "inactive";

function doMenu(chosenItem) {
    var poolManager = new menuItemHandler();
    var trigger = window.document.getElementById(chosenItem);
    /* Toggle the display of the subMenus and flip the image for the menuitem */    
    poolManager.getItemById(trigger).toggleMenu();
}

/**************
 *** Classes ***
 **************/
 
/* This is the 'class' definition of the menu item pool handler */
function menuItemHandler() {
    /* methods */
    this.getItemById = getById;
    this.addItem = addNewItemToPool;
    this.removeItem = removeItemFromPool;
    this.closeOthers = closeAllOtherItems;
}

/* This is the 'class' deifinition of a menu item */
function menuItem(triggerElement) {
    /* Methods */
    this.toggleMenu       = switchMenuVisibility;
    this.setActiveState    = setActive;
    this.setInactiveState = setInactive;
    this.mouseOver        = setMouseOver;
    this.mouseOut         = setMouseOut;
    this.isMenuOpen      = isItemOpen;
    this.isActive             = isItemActive;
    this.setOpen            = setMenuOpen;
    this.setClosed          = setMenuClosed;

    /* Fields */
    this.id = triggerElement.id;    
    this.menuStatus = menuItem.CLOSED; //The current status of the menu item itself always closed first time
    this.menuItemStatus = menuItem.INACTIVE; //The current status of the menuItem's menu initialiy active
    this.handler = ""; //Set by the handler add method
    this.parent = triggerElement.parentNode.id; //Store the id of the parent
    this.mover = 0; //the count of the number of mouse over events
    
     /* 'Constructor' - find the child div, the subMenuItem and the icon (img) */
    for (var n = 0; n < triggerElement.childNodes.length; n++) {
        var element = triggerElement.childNodes[n];
		/* Get a handle to the img and div tags of the menu container */
		if (element.tagName == "IMG") {
			this.img = element;
		}
		else if(element.tagName == "DIV") {
			this.menuDiv = element;
		}
        else if(element.tagName == "SPAN") {
           for (var c = 0; c < element.childNodes.length; c++) {
               if(element.childNodes[c].tagName == "A") {
                    this.anchor = element.childNodes[c];
                }
            }
		}
    }
}

/**************
 *** Methods ***
 **************/

 /* A function (method) of openItemHandler to get an item from the pool using it's id */
function getById(itemToGet) {
    var retVal;
    //Loop thru the pool looking for the matching item id
	for (var n = 0; n < menuItemHandler.pool.length; n++){
        if (menuItemHandler.pool[n].id == itemToGet.id) {
            retVal = menuItemHandler.pool[n];
			n = menuItemHandler.pool.length; //break the loop
        }
    }
    //not found in the pool so create a new one and add it to the pool
    if (retVal == null) {
        retVal = new menuItem(itemToGet);
        retVal.handler = this; //Give the menu item a ref back to the handler
        this.addItem(retVal);
    }
    //Send back what we found or created.
    return retVal;
}

function itemStatusHandler(proprertyName, origVal, proposedVal) {
    alert(propertyName+" changed from "+origVal+" to "+proposedVal);
    return proposedVal;
}

 /* is the item's active return true else return false */
function isItemActive() {
    retVal = false;
    if (this.menuItemStatus == menuItem.ACTIVE) { retVal = true; }
    return retVal;
}
 
/* returns a boolean value based representing the open or closed state of the item */
function isItemOpen() {
    var retVal = true;
    if (this.menuStatus == menuItem.CLOSED) { retVal = false; }
    return retVal;
}

/* Function handles the mouse over for the item */
function setMouseOver(){
    this.setActiveState();
    this.mover++; //increase the count of focus gains for this object
}

/* function that handles the mouse out event for the item */
function setMouseOut() {
    this.mover--; //decrease the count of focus gains for this object
    /* Only set to inactive if the item with focus isn't currently active and hasn't got kb or mouse focus */
    if (this.isMenuOpen() == false && this.isActive() == true && this.mover == 0) {
        this.setInactiveState();
    }
}

/* set the menu item to display inactive */
function setInactive() {
    this.img.src = imgGreyed.src;	
	this.anchor.className = menuItem.CSS_INACTIVE;
    this.menuItemStatus = menuItem.INACTIVE;
}

/* set the menu item to display active */
function setActive() {
	this.anchor.className = menuItem.CSS_ACTIVE;
    this.menuItemStatus = menuItem.ACTIVE;
    if (this.isMenuOpen() == true) {
        this.img.src = imgOpen.src;
    } else {
        this.img.src = imgClosed.src;
    }
}

/* open the menu and switch the gif */
function setMenuOpen() {
    this.menuDiv.style.display = "block";
    this.menuStatus = menuItem.OPEN;
    this.img.src = imgOpen.src;
}

/* close the menu and flip the gif */
function setMenuClosed() {
    this.menuDiv.style.display = "none";
    this.menuStatus = menuItem.CLOSED;
    this.img.src = imgClosed.src;
}

/* Function (method) of menuItem to toggle the display of the menu DIV */
function switchMenuVisibility(itemToSwitch){
    /* if currently open then close, otherwise.....*/
    if (this.isMenuOpen() == true) {
        this.setClosed();
        /*.....currently closed so open and close all others */
    } else {
        this.setOpen();
        this.setActiveState();
        this.handler.closeOthers(this);
    }
}

/* A function (method) of openItemhandler that adds a new item to the item pool */
function addNewItemToPool(itemToAdd) {
    menuItemHandler.pool[menuItemHandler.pool.length] = itemToAdd;
}

/* THIS FUNCTION IS UNUSED - left in case it's required in future */
/* Function (method) to remove the passed item from the pool of menu items */
function removeItemFromPool(itemToRemove) {
    for (var n = 0; n < menuItemHandler.pool.length; n++) {
        if (menuItemHandler.pool[n].id == itemToRemove.id) {
            spliceItemFromArray(menuItemHandler.pool, n);
        }
    }
}

/* Function (method) of the handler to close all menu items except the one passed in */
function closeAllOtherItems(itemToLeaveOpen) {
    /* loop thru the pool of menu items */
    for (var n = 0; n < menuItemHandler.pool.length; n++)
    {
        if (menuItemHandler.pool[n].isMenuOpen() == true) //if the item is open...
        { 
			if (menuItemHandler.pool[n].id != itemToLeaveOpen.id) //...and the iteration is not the current item....
            { 
                if (menuItemHandler.pool[n].parent == itemToLeaveOpen.parent)  //..and isn't in the same level as the current item
                {
                    menuItemHandler.pool[n].toggleMenu(); //..close the menu.
                    menuItemHandler.pool[n].setInactiveState(); //set the display to inactive state
                }
            }
        }
    }
}

/* Remove the item at index from array */
function spliceItemFromArray(array, index) {
    for (var cnt = index; cnt < (array.length-1); cnt++){
        array[cnt] = array[cnt+1];
    }
    array.length = (array.length-1);
}

/* Handles the highlighting of the menu item under the pointer */
function menuMouseOver(trigger) {
    var handler = new menuItemHandler();
    handler.getItemById(window.document.getElementById(trigger)).mouseOver();
}

/* Handles the re-setting of the menu item when mouse pointer removed */
function menuMouseOut(trigger) {
    var handler = new menuItemHandler();
    handler.getItemById(window.document.getElementById(trigger)).mouseOut();
} 
